# makefile
DEBIAN = $(shell uname -s)-$(shell uname -m)
HOME = .
BIN = $(HOME)/bin/$(DEBIAN)
SRC = $(HOME)/src

#DEFS = -DDEBUG
CFLAGS = -g
CC = gcc
LD = gcc
LDFLAGS = -lm
RM = rm -rf


#Création des dossier
$(shell mkdir -p $(BIN))
$(shell mkdir -p $(BIN)/hello)
$(shell mkdir -p $(BIN)/horloge)
$(shell mkdir -p $(BIN)/type_retour_fonction)
$(shell mkdir -p $(BIN)/degre)

all : helloWorldAvant helloWorldApres helloWorldHeader helloWorldHeaderDef horloge type_retour_fonction type_retour_fonction degre

hello : helloWorldAvant helloWorldApres helloWorldHeader helloWorldHeaderDef

degre : testdegre1 testdegre2

helloWorldAvant :

	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/hello/helloWorldAvant.c -o $(BIN)/hello/helloWorldAvant.o
	$(LD) $(LDFLAGS) $(BIN)/hello/helloWorldAvant.o -o $(BIN)/hello/helloWorldAvant

helloWorldApres :

	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/hello/helloWorldApres.c -o $(BIN)/hello/helloWorldApres.o

	$(LD) $(LDFLAGS) $(BIN)/hello/helloWorldApres.o -o $(BIN)/hello/helloWorldApres

helloWorldHeader :

	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/hello/helloWorldHeader.c -o $(BIN)/hello/helloWorldHeader.o

	$(LD) $(LDFLAGS) $(BIN)/hello/helloWorldHeader.o -o $(BIN)/hello/helloWorldHeader

helloWorldHeaderDef :

	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/hello/helloWorldHeaderDef.c -o $(BIN)/hello/helloWorldHeaderDef.o

	$(LD) $(LDFLAGS) $(BIN)/hello/helloWorldHeaderDef.o -o $(BIN)/hello/helloWorldHeaderDef

horloge :

	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/horloge/horloge.c -o $(BIN)/horloge/horloge.o

	$(LD) $(LDFLAGS) $(BIN)/horloge/horloge.o -o $(BIN)/horloge/horloge

type_retour_fonction :
	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/type_retour_fonction/type_retour_fonction.c -o $(BIN)/type_retour_fonction/type_retour_fonction.o

	$(LD) $(LDFLAGS) $(BIN)/type_retour_fonction/type_retour_fonction.o -o $(BIN)/type_retour_fonction/type_retour_fonction

testdegre1 :
	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/degre/testdegre1.c -o $(BIN)/degre/testdegre1.o

	$(LD) $(LDFLAGS) $(BIN)/degre/testdegre1.o -o $(BIN)/degre/testdegre1

testdegre2 :
	$(CC) $(CFLAGS) $(DEFS) -c $(SRC)/degre/testdegre2.c -o $(BIN)/degre/testdegre2.o

	$(LD) $(LDFLAGS) $(BIN)/degre/testdegre2.o -o $(BIN)/degre/testdegre2
clean :
	@echo --- Nettoyage des fichiers temporaires ---
	@-$(RM) $(BIN)/*
